
/**
 * 应用程序初始化类
 */
function AppInit()
{
	//this.BaseUrl="http://192.168.1.183:8080/QNGService";
	//this.BaseServiceUrl=this.BaseUrl+"/QNGService";
	//this.BaseUrl="http://lihanren3.jsp.78host.com";
	this.BaseUrl="http://www.shangnagou.cn";
	this.BaseServiceUrl=this.BaseUrl;
	//APP检测更新地址
	this.CheckUpdateUrl=this.BaseServiceUrl+"/app/update.html";
	//Android下载地址
	this.ApkDownUrl=this.BaseServiceUrl+"/app/sng.apk";
	/**********分享红包的参数**************/
	//分享的链接
	this.shareUrl=this.BaseServiceUrl+"/app/share.html";
	//分享的标题
	this.shareTitle="购物就去上哪购";
	//分享的连接描述
	this.shareDescribe="上哪购是一个综合购物平台，让你轻松找到最实惠的最满意的购物方式";
};

/**
 * 测试功能是否正常
 */
AppInit.prototype.testInit=function()
{
	alert("Hello World");
};

/**
 * 初始化首页下面的导航菜单栏
 */
AppInit.prototype.initMenu=function()
{
	var url= this.BaseServiceUrl+"/Menu/getNavigateBar";
	
	Common.get(url,null,function(data){
		var i=0;
		$('#tabbar a').each(function(){
			var name=data[i].name;
			var icon=data[i].image;
			i++;
			var content='<span class="mui-icon '+icon+'"></span>';
				content+='<span class="mui-tab-label">'+name+'</span>';
			$(this).append(content);
		});
	},function(){});
};

/**
 * 初始化首页轮播图
 */
AppInit.prototype.initSlider=function()
{
	var url= this.BaseServiceUrl+"/Index/initSlider";
	
	function success(data)
	{
		var images={sliderImages:data};
		
		new Vue({
			el:'#slider',
			data:images,
			methods:{
				onClick:function(e)
				{
					Common.onClick(e);
				}
			}
		});
		
		mui("#slider").slider({
						interval: 2500//图片自动轮播
					});
	};
	
	Common.get(url,null,success,function(){});
};

/**
 * 初始化小导航栏，就是轮播图下面的那个导航栏
 */
AppInit.prototype.initSmallNav=function()
{
	var url= this.BaseServiceUrl+"/Index/initSmallNav";
	
	function success(data)
	{
		var items={smallNavItems:data};
		
		new Vue({
			el:'#small-nav-list',
			data:items,
			methods:{
				onClick:function(e)
				{
					Common.onClick(e);
				}
			}
		});
		;
	};
	Common.get(url,null,success,function(){});
};

/**
 * 初始化大的导航栏，就是小导航栏下面的导航栏
 */
AppInit.prototype.initBigNav=function()
{
	var url= this.BaseServiceUrl+"/Index/initBigNav";
	
	function success(data)
	{
		var horizontalItem=new Array();
		var verticalItem=new Array();
		
		for(var i=0;i<data.length;i++)
		{
			if(data[i].displayStyle==1)//1表示水平布局
			{
				horizontalItem.push(data[i]);
			}
			else if(data[i].displayStyle==0)//0表示竖直布局
			{
				verticalItem.push(data[i]);
			}
		}
		
		new Vue({
			el:'#big-nav-item-vertical',
			data:{bigNavVerticalItems:verticalItem},
			methods:{
				onClick:function(e)
				{
					Common.onClick(e);
				}
			}
		});
		
		new Vue({
			el:'#big-nav-item-horizontal',
			data:{bigNavHorizontalItems:horizontalItem},
			methods:{
				onClick:function(e)
				{
					Common.onClick(e);
				}
			}
		});
		 
		
	};
	Common.get(url,null,success,function(){});
};

/**
 * 初始化网站导航栏
 */
AppInit.prototype.initWebNav=function()
{
	var url= this.BaseServiceUrl+"/Index/initWebNav";
	
	function success(data)
	{
		var num=parseInt(data.length/3);//取整，多余的不要
		
		new Vue({
			el:'#web-nav',
			data:{
				nums:num,
				rowNums:3
			},
			methods:{
				onClick:function(e)
				{
					Common.onClick(e);
				}
			}
		});
		
		var index=0;
		
		$("a[mark='web-nav']").each(function(){
			$(this).attr("targetUrl",data[index].targetUrl);
			$(this).find("img").attr("src",data[index].imageUrl);
			index++;
		});
	};
	Common.get(url,null,success,function(){});
};

/**
 * 初始化单个商品的导航栏
 */
AppInit.prototype.initSingleGoods=function()
{
	var url= this.BaseServiceUrl+"/Index/initSingleGoods";
	
	function success(data)
	{
		//var num=parseInt(data.length/2);//取整，多余的不要
		var num=Math.ceil(data.length/2);//向上取整，有小数就整数部分加1
		
		if(data.length%2==1)//表示多出了一个，需要添加一个空白的图片
		{
			var item={targetUrl:"",imageUrl:"img/blank.png",platform:"",introduce:"",price:"",validMinute:""};
			data.push(item);
		}
		
		var singleGoodsComponent= new SingleGoodsComponent({
			data:{
				nums:num,
				rowNums:2
			},
			methods:{
				onClick:function(e)
				{
					Common.onClick(e);
				}
			}
		});
		
		singleGoodsComponent.$mount('#single-goods-container');
		
		var index=0;
		
		$("a[mark='single-goods-nav']").each(function(){
			$(this).attr("targetUrl",data[index].targetUrl);
			$(this).find("img").attr("src",data[index].imageUrl);
			if(data[index].imageUrl!='img/blank.png')
			{
				$(this).find("b[mark='single-goods-platform']").html("&nbsp;"+data[index].platform+"&nbsp;");
				$(this).find("label[mark='single-goods-introduce']").html(data[index].introduce);
				var integerValue=parseInt(data[index].price);
				var decimalValue=(data[index].price-integerValue).toFixed(2);
				$(this).find("b[mark='single-goods-integer']").html("￥"+integerValue);
				var decimalStr=decimalValue.toString();
				$(this).find("b[mark='single-goods-decimal']").html(decimalStr.substring(1,decimalStr.length));
				
				var validAllMinute=data[index].validMinute;
				var validDecimalHour=validAllMinute/60;
				var validHour=parseInt(validDecimalHour);//小时
				var validMinute=parseInt((validDecimalHour-validHour)*60);//分钟
				
				validHour=validHour<10?"0"+validHour.toString():validHour.toString();
				validMinute=validMinute<10?"0"+validMinute.toString():validMinute.toString();
				
				$(this).find("font[mark='single-goods-countdown']").html("剩 <b>"+validHour+":"+validMinute+"</b>分");
				$(this).find("font[mark='single-goods-countdown']").attr("validMinute",validAllMinute);
			}
			else//给空白图片的位置的倒计时赋值为一个特大的值，这样就不会因为该值的原因而导致频繁刷新
			{
				$(this).find("font[mark='single-goods-countdown']").attr("validMinute",999999999);
			}
			
			index++;
		});
		
		/**
		 * 闭包
		 * 刷新单商品栏
		 */
		function refreshSingleGoods()
		{
			$("font[mark='single-goods-countdown']").each(function(){
				var validAllMinute= $(this).attr("validMinute");
				validAllMinute=validAllMinute-1;//减去一分钟
				if(validAllMinute<=0)
				{
					$("#single-goods-container").html();//清空原来的内容
					//先清除已存在的单商品定时任务
					window.clearInterval(Common.Interval["singleGoodsInterval"]);
					//重新加载单商品
					new AppInit().initSingleGoods();
					return;//只要有一个时间过期，就刷新整个单商品布局栏，就不需要继续循环下去
				}
				else
				{
					var validDecimalHour=validAllMinute/60;
					var validHour=parseInt(validDecimalHour);//小时
					var validMinute=parseInt((validDecimalHour-validHour)*60);//分钟
					
					validHour=validHour<10?"0"+validHour.toString():validHour.toString();
					validMinute=validMinute<10?"0"+validMinute.toString():validMinute.toString();
					
					$(this).html("剩 <b>"+validHour+":"+validMinute+"</b>分");
					$(this).attr("validMinute",validAllMinute);
				}
			});
		}
		
		//重复执行,设置定时器对象
		Common.Interval["singleGoodsInterval"]=window.setInterval(refreshSingleGoods,60*1000);//一分钟刷新一次
	};
	Common.get(url,null,success,function(){});
};

/**
 * 初始化福利界面
 */
AppInit.prototype.initWelfare=function()
{
	new Welfare().refreshWelfare();
	
	/*var walfareUrl=this.BaseServiceUrl+"/Welfare/getWelfStartTime";
	
	Common.get(walfareUrl,null,function(data)
	{
		var validSecond=data.subTime;
		var welftimeId=data.welftimeId!=null?data.welftimeId:"";
		
		function calValidTime(validSecond)
		{
			if($("#welfarecountdown").attr("validSecond")=="")
			{
				$("#welfarecountdown").attr("validSecond",validSecond);
				$("#welfarecountdown").attr("welftimeId",welftimeId);
			}
			else
			{
				validSecond=validSecond-1;
				$("#welfarecountdown").attr("validSecond",validSecond);
				$("#welfarecountdown").attr("welftimeId",welftimeId);
			}
			
			if(validSecond>=0)
			{
				var hour=parseInt(validSecond/(60*60));
				var minute=parseInt(validSecond/60-hour*60);
				var second=parseInt(validSecond-minute*60-hour*60*60);
			
				hour=hour<10?"0"+hour.toString():hour.toString();
				minute=minute<10?"0"+minute.toString():minute.toString();
				second=second<10?"0"+second.toString():second.toString();
				
				$("#welfare-hour").html(hour);
				$("#welfare-minute").html(minute);
				$("#welfare-second").html(second);
			}
			else
			{
				//先把定时器干死
				window.clearInterval(Common.Interval["welfareInterval"]);
				//重置为0
				$("#welfarecountdown").attr("validSecond",0);
				$("#welfarecountdown").attr("welftimeId",welftimeId);
			}
		}
		
		function refreshWelfareCountDown()
		{
			var validSecond= $("#welfarecountdown").attr("validSecond");
			calValidTime(validSecond);
		}
		
		calValidTime(validSecond);
		
		Common.Interval["welfareInterval"]=window.setInterval(refreshWelfareCountDown,1000);//一秒钟刷新一次
		
	},function(){});*/
	
	var shareDescribe=Common.shareDescribe!=null?Common.shareDescribe:this.shareDescribe;
	var shareTitle=Common.shareTitle!=null?Common.shareTitle:this.shareTitle;
	var shareUrl=Common.shareUrl!=null?Common.shareUrl:this.shareUrl;
	
	function checkShareParam()
	{
		shareDescribe=Common.shareDescribe!=null?Common.shareDescribe:shareDescribe;
		shareTitle=Common.shareTitle!=null?Common.shareTitle:shareTitle;
		shareUrl=Common.shareUrl!=null?Common.shareUrl:shareUrl;
	}
	
	function shareMessage(msg,s)
	{
		//outLine(JSON.stringify(msg));
		s.send( msg, function()
		{
			//mui.alert( "分享到\""+s.description+"\"成功！ ","提示","确定",function(){});
			mui.alert( "分享到\""+currentSharePlatform+"\"成功！ ","提示","确定",function(){});
			if(currentSharePlatform=="微信朋友圈")
			{
				new Welfare().getRedPackets();
			}
		}, 
		function(e)
		{
			//mui.alert( "分享到\""+currentSharePlatform+"\"失败: "+JSON.stringify(e),"提示","确定",function(){} );
			mui.alert("分享到\""+currentSharePlatform+"\"失败,请重新分享","提示","确定",function(){});
		});
	}
	
	function shareAction(sb,bh)
	{
		checkShareParam();
		
		if(!sb||!sb.s)
		{
			mui.alert("无效的分享服务","提示","确定",function(){});
			return;
		}
		var msg=
		{
			content:shareDescribe,
			extra:{scene:sb.x},
			title:shareTitle,
			href:shareUrl
		};
		// 发送分享
		if ( sb.s.authenticated ) 
		{
			//mui.alert("已授权","提示","确定",function(){});
			shareMessage(msg,sb.s);
		} 
		else
		{
			//mui.alert("未授权","提示","确定",function(){});
			sb.s.authorize( function()
			{
				shareMessage(msg,sb.s);
			},function(e)
			{
					mui.alert("认证授权失败"+e.code+" - "+e.message,"提示","确定",function(){});
				//outLine( "认证授权失败："+e.code+" - "+e.message );
			});
		}
	}
	
	//分享查看，分享到微信朋友圈
	$("#shard-WXSceneTimeline").click(function()
	{
		var validSecond=$("#welfarecountdown").attr("validSecond");
		if(validSecond>0)
		{
			mui.alert("抢红包尚未开始，请耐心等待 。。。","提示","确定",function(){});
			return;
		}
		
		var ss=shares['weixin'];
		if(ss&&ss.nativeClient)
		{
			var para={title:'微信朋友圈',s:ss,x:'WXSceneTimeline'};
			currentSharePlatform="微信朋友圈";
			shareAction(para,true);
		}
		else
		{
			plus.nativeUI.alert('当前环境无法支持分享链接操作!');
		}
	});
	
	//领取口令介绍
	$("#welfare-introduce").click(function()
	{
		
	});
	//分享APP至微信好友
	$("#welfare-share").click(function()
	{
		var ss=shares['weixin'];
		if(ss&&ss.nativeClient)
		{
			var para={title:'微信好友',s:ss,x:'WXSceneSession'};
			currentSharePlatform="微信好友";
			shareAction(para,true);
		}
		else
		{
			plus.nativeUI.alert('当前环境无法支持分享链接操作!');
		}
	});
};

/**
 * 检测升级
 */
AppInit.prototype.checkUpdate=function()
{
	var xhr=new XMLHttpRequest();
	
	xhr.onreadystatechange=function()
	{
		switch(xhr.readyState)
		{
			case 4:
			if(xhr.status==200)
			{
				var newVer=xhr.responseText;
				if(wgtVer&&newVer&&(wgtVer!=newVer))
				{
					plus.nativeUI.showWaiting("正在下载更新,请稍后");
					downApk();
				}
			}
		}
	};
	
	xhr.open('GET',this.CheckUpdateUrl);
	xhr.send();
	
	var downUrl=this.ApkDownUrl;
	/**
	 * 下载升级包
	 */
	function downApk()
	{
		var dtask=plus.downloader.createDownload(downUrl,{},function(d,status)
		{
			if(status==200)
			{
				
				var path=d.filename;
				plus.runtime.install(path);
			}
			else
			{
				plus.nativeUI.alert('下载失败 ...');
			}
			plus.nativeUI.closeWaiting();
		});
		
		dtask.start();
	}
};

AppInit.prototype.getInternetDate=function()
{
	var xhr=new XMLHttpRequest();
	xhr.onreadystatechange=function()
	{
		switch(xhr.readyState)
		{
			case 4:
			if(xhr.status==200)
			{
				var date= xhr.getResponseHeader("Date");
				mui.alert(date);
			}
		}
	};
	
	xhr.open("OPTIONS","http://www.taobao.com");
	xhr.send();
};

/**
 * 获取红包分享的参数
 */
AppInit.prototype.getShareParam=function()
{
	var url= this.BaseServiceUrl+"/Welfare/getShareParam";
	
	function success(data)
	{
		if(data.shareUrl)
		{
			Common.shareUrl=data.shareUrl;
		}
		if(data.shareTitle)
		{
			Common.shareTitle=data.shareTitle;
		}
		if(data.shareDescribe)
		{
			Common.shareDescribe=data.shareDescribe;
		}
	};
	
	Common.get(url,null,success,function(){});
};
